global.ch = {}
global.bases = {{},{},108000}
global.units = {}
global.df = {0,"none",1,0,1,0}
global.targets = {{},{}}
global.players = {}
global.livesystem = {0,0,0,{},0}
global.time = {0,0,0,0,0}
global.ship = {nil,nil,0,0}
global.lzrs = {{},{},{}}
global.fr = {{},{}}
global.guns = {{},{},{},{},{}}
global.group = {{120*120,0},{},{},{}} --timer/points/group/units
global.turrets = {{{},{}},{{},{}}}
global.expirience = {}
global.counters = 0
global.observ = {{},{},{1,0,{}}}
global.abomb = {{},{}}



local function base_res(base,index)
	for y,u in ipairs(base[6]) do
		if not u[1].valid then
			table.remove(base[6], y)
		elseif math.random(60) == 1 then
			if not u[2].valid then
				u[2] = game.surfaces[1].create_entity{name = "elerium-ore", position = u[1].position, force =  game.forces.neutral, amount = math.random(3)}
			else
				local cnt = 0
				if math.random(1, u[2].amount) > 250 then cnt = -1
				elseif math.random(1, u[2].amount) < 50 then cnt = 1
				end
				u[2].amount = u[2].amount + cnt
			end
		elseif math.random(9) == 1 and game.surfaces[1].get_pollution({u[1].position.x, u[1].position.y}) > (82-2*global.df[5])*3 then 
			base[4][1] = base[4][1] + (0.9+0.06*global.df[1])
			game.surfaces[1].pollute({u[1].position.x, u[1].position.y}, -(92-2*global.df[5])*3)
		end
	end
	if math.random(10) == 1 then
		for i=1,1+#base[6] do
			base[4][1] = base[4][1] + (0.9+0.06*global.df[1])
		end
	elseif math.random(3) == 1 and game.surfaces[1].get_pollution({base[1].position.x, base[1].position.y}) > 82-2*global.df[5] then 
		base[4][1] = base[4][1] + (0.3+0.02*global.df[1])
		game.surfaces[1].pollute({base[1].position.x, base[1].position.y}, -(92-2*global.df[5]))
	end
	if #base[5] > 0 and base[4][2] < 100 then
		base[4][2] = base[4][2] + (1+(0.05*global.df[1]*#base[5]))
	end
end

local function base_defence(base,index)
	if base[4][1] > 0 and base[4][2]< 0 then
		base[4][2] = base[4][2] + base[4][1]
		base[4][1] = 0
	end
	global.temp = {}
	if base[3][2] > 0 and not base[3][1].valid then 
		base[3][2] = base[3][2] - 1
	elseif base[3][2] == 0 and not base[3][1].valid then
		base[3][1] = game.surfaces[1].create_entity{name = "queen", position = find_random_point(base[1].position, 10, "ne01", 1000, 1), force =  game.forces.enemy}
		base[3][2] = math.ceil(1080/global.df[1])
	end
	for y,u in ipairs(base[5]) do
		global.temp = {}
		if not u[1].valid then
			for q,w in ipairs(u[2]) do
				if w.valid then
					w.die()
				end
			end
			table.remove(base[5], y)
		elseif u[1].valid then
			u[1].health = u[1].health + 4*global.df[1]*(4+#game.players)*#u[2]
			for q,w in ipairs(u[2]) do
				if not w.valid then
					table.remove(u[2], q)
				elseif string.sub(w.name,1,3) == "co0" then
					table.insert(global.temp, w)
				end
			end
			if #u[3] > 0 then
				if #u[4] < global.df[1]/3+#global.temp and #base[7] < 1.4*global.df[1]*#base[5] then
					local ent = game.surfaces[1].create_entity{name = "egg", position = find_random_point(u[1].position, 5, "su01", 1000, 1), force =  game.forces.neutral}
					ent.health = math.random(2*global.df[1])
					table.insert(u[4], {ent,u[3][1]})
					for q,w in ipairs(global.temp) do
						local ent = game.surfaces[1].create_entity{name = "egg", position = find_random_point(w.position, 5, "su01", 1000, 1), force =  game.forces.neutral}
						ent.health = math.random(2*global.df[1])
						table.insert(u[4], {ent,u[3][1]})
					end
					table.remove(u[3], 1)
				end
			end
			for q,w in ipairs(u[4]) do
				if not w[1].valid then
					table.remove(u[4], q)
				elseif w[1].health == 100 then
					for i=1,w[2][2] do
						local ent = game.surfaces[1].create_entity{name = w[2][1], position = find_random_point(w[1].position, 1, w[2][1], 1000, 1), force =  game.forces.enemy}
						table.insert(base[7], {ent,w[2][4],{w[2][1],1,w[2][3]}})
						ent.set_command({type=defines.command.wander, radius=15 ,distraction=defines.distraction.by_enemy})
					end
					w[1].die()
				end
			end
		end
	end
	for y,u in ipairs(base[7]) do
		if not u[1].valid then
			table.remove(base[7], y)
		end
	end
	base[1].health = base[1].health + 10*(3+global.df[1])*(4+#game.players)*(#base[5]+0.1*#base[6])
end

local function base_destroy(base,index)
	if base[3][1].valid then base[3][1].die() end
	for y,u in ipairs(base[5]) do
		if u[1].valid then u[1].die() end
		for q,w in ipairs(u[2]) do
			if w.valid then w.die() end
		end
		for q,w in ipairs(u[4]) do
			if w.valid then w.die() end
		end
	end
	for y,u in ipairs(base[6]) do
		if u[1].valid then u[1].die() end
	end
	for y,u in ipairs(base[7]) do
		if u[1].valid then
			if global.df[3] ~= 0 then
				table.insert(global.group[4], u[3])
				u[1].destroy()
			else u[1].die()
			end
		end
	end
	game.evolution_factor = game.evolution_factor + 0.002
	table.remove(global.bases[2], index)
end

local function base_peace(base,index)
	if #base[7] > 0 then
		if base[7][1][1].valid then
			base[4][2] = base[4][2] +  base[7][1][2]
			base[7][1][1].destroy()
			table.remove(base[7], 1)
		else table.remove(base[7], 1) end
	end
	if base[3][1].valid then
		base[3][1].destroy()
		base[3][2] = 0
	else base[3][2] = 0 end
end

local function base_ability(base,index,resources,tier)
	base[4][1] = base[4][1] - resources
	if tier == 1 then
		table.insert(global.group[4], {"zrlg5",global.temp[1],200})
	elseif tier == 2 then
		table.insert(global.group[4], {"queen",1,1000})
	elseif tier == 3 then
		repeat
			local well = false
			local roll = math.random(#global.targets[1])
			if global.targets[1][roll].valid then
				local ent = game.surfaces[1].create_entity{name = "abomb", position = base[1].position, force =  game.forces.neutral}
				ent.set_command{type=defines.command.attack, target=global.targets[1][roll], distraction=defines.distraction.by_enemy}
				table.insert(global.units, {ent, 200})
				table.insert(global.targets[2], ent)
				table.insert(global.abomb, ent)
				well = true
			else table.remove(global.targets[1], roll) end
		until well
	end
end

local function base_expand(base,index)
	global.temp = {}
	if string.sub(base[1].name,1,3) == "ne0" then global.temp[1] = 1 global.temp[2] = 8
	elseif string.sub(base[1].name,1,3) == "la0" then global.temp[1] = 2 global.temp[2] = 16
	elseif string.sub(base[1].name,1,3) == "hi0" then global.temp[1] = 3 global.temp[2] = 24 end
	local tier = global.df[5]
	local roll = math.random(5)
	if global.df[3] == 0 and roll == 2 then
		roll = 1
	end
	if roll == 1 and #base[5] < global.temp[2] then
		local roll = math.random(1+2*global.temp[1])
		if #base[6] == 0 then roll = 1
		elseif global.df[3] == 0 then
			if roll == 4 then
				roll = math.random(3)
			elseif roll == 10 then
				roll = math.random(5,9)
			end
		end
		if roll == 1 then global.temp[3] = {200, "ex",base[1].position,25,0}
		elseif roll == 2 then global.temp[3] = {200, "nu0"..tier,base[1].position,25,0}
		elseif roll == 3 then global.temp[3] = {150, "po0"..tier,base[1].position,25,0}
		elseif roll == 4 then base_ability(base,index,100,1)
		
		elseif roll == 5 then global.temp[3] = {450, "de0"..tier,base[1].position,25,0}
		elseif roll == 6 then global.temp[3] = {550, "mo0"..tier,base[1].position,25,0}
		elseif roll == 7 then global.temp[3] = {700, "sp0"..tier,base[1].position,25,0}
		
		elseif roll == 8 then global.temp[3] = {900, "ch0"..tier,base[1].position,25,0}
		elseif roll == 9 then global.temp[3] = {1300, "ca0"..tier,base[1].position,25,0}
		elseif roll == 10 then base_ability(base,index,90,3) end
		
	elseif roll == 2 then
		local roll = math.random(global.temp[1])
		
		if roll == 1 then base_ability(base,index,100,1)
		elseif roll == 2 then base_ability(base,index,200,2)
		elseif roll == 3 then base_ability(base,index,90,3) end
		
	elseif #base[5] > 0 then
		for i,b in ipairs(base[5]) do
			if #b[2] < global.temp[1] then
				local roll = math.ceil(math.random(1+global.temp[1])/2)
				if b[1].name == "ex" then roll = 1 end
				if roll == 1 then global.temp[3] = {100, "su0"..tier,b[1].position,10,i}
				elseif roll == 2 then global.temp[3] = {200, "co0"..tier,b[1].position,10,i}
				end
				
				break
			end
		end
	end
	if global.temp[3] ~= nil then
		local rp = find_random_point(global.temp[3][3], global.temp[3][4]*global.temp[1], global.temp[3][2], 1000, 1)
		clear_area(rp)
		if rp ~= nil and math.sqrt((rp.x-global.temp[3][3].x)^2+(rp.y-global.temp[3][3].y)^2) > 6*global.temp[1] then
			local ent = game.surfaces[1].create_entity{name = global.temp[3][2], position = rp, force =  game.forces.enemy}
			base[4][1] = base[4][1] - global.temp[3][1]
			if global.temp[3][5] == 0 then
				table.insert(base[5], {ent,{},{},{}})
			else table.insert(base[5][global.temp[3][5]][2], ent) end
			if global.temp[3][2] == "ex" then
				local ent2 = game.surfaces[1].create_entity{name = "elerium-ore", position = rp, force =  game.forces.neutral, amount = math.random(10)}
				ent.teleport(ent2.position)
				table.insert(base[6], {ent,ent2})
			end
		end
	end
	if math.random(8) == 1 then
		if #base[5] >= 4 and global.temp[1] == 1 then
			base[4][1] = base[4][1] - math.random(550)
			local ent = game.surfaces[1].create_entity{name = "la0"..global.df[5], position = base[1].position, force =  game.forces.enemy}
			for j = 1,50 do clear_area(find_random_point(base[1].position, 100, "dflr1", 15, 1)) end
			base[1].destroy()
			base[1]=ent
		end
		if #base[5] >= 12 and global.temp[1] == 2 then
			base[4][1] = base[4][1] - math.random(1500)
			local ent = game.surfaces[1].create_entity{name = "hi0"..global.df[5], position = base[1].position, force =  game.forces.enemy}
			for j = 1,50 do clear_area(find_random_point(base[1].position, 200, "dflr1", 15, 1)) end
			base[1].destroy()
			base[1]=ent
		end
	end
end

local function base_spawn(base,index)
	global.temp = {}
	global.temp[1] = base[5][math.random(#base[5])]
	global.temp[2] = string.sub(global.temp[1][1].name,1,3)
	local tier = math.ceil(global.df[5]/5)
	if global.temp[2] == "po0" and math.random(4) ~= 1 then global.temp[3] = {60,"zrlg"..tier,2,120}
	elseif global.temp[2] == "po0" then global.temp[3] = {60,"bnlg"..tier,1,120}
	elseif global.temp[2] == "nu0" and math.random(4) ~= 1 then global.temp[3] = {60,"scrg"..tier,4,120}
	elseif global.temp[2] == "nu0" then global.temp[3] = {80,"sclg"..tier,1,120}
	elseif global.temp[2] == "de0" then global.temp[3] = {225,"hdsk"..tier,1,200}
	elseif global.temp[2] == "mo0" then global.temp[3] = {250,"roch"..tier,1,200}
	elseif global.temp[2] == "ca0" then global.temp[3] = {650,"utsk"..tier,1,400}
	elseif global.temp[2] == "ch0" then global.temp[3] = {475,"lrkr"..tier,1,400}
	elseif global.temp[2] == "sp0" then global.temp[3] = {550,"dflr"..tier,1,500} end
	if #global.temp[1][3] < 2*global.df[1] and global.temp[3] ~= nil then
		table.insert(global.temp[1][3], {global.temp[3][2],global.temp[3][3],global.temp[3][4],global.temp[3][1]})
		base[4][2] = base[4][2] - global.temp[3][1]
	elseif #global.temp[1][3] >= 2*global.df[1] and global.temp[3] ~= nil and global.group[1][2] == 0 then
		base[4][2] = base[4][2] - global.temp[3][1]
		if math.random(global.df[1]*2, 30) >= 28 then
			if global.df[3] ~= 0 then
				table.insert(global.group[4], {global.temp[3][2],global.temp[3][3],global.temp[3][4]})
			else base[4][2] = base[4][2] + 2*global.temp[3][1]
			end
		end
	end
end

local function base_control(base,index)
	base_res(base,index)
	if base[2][1] then
		base[2][1] = false
		base[2][2] = 120
	end
	if base[2][2] > 0 then
		base[2][2]  = base[2][2]-1
		base_defence(base,index)
	elseif base[2][2] == 0 then
		base_peace(base,index)
	end
	if base[4][1] >= 0 then
		base_expand(base,index)
	end
	if base[4][2] >= 0 and #base[5] > 0 then
		base_spawn(base,index)
	end
end

local function unit_time()
	for y,u in ipairs(global.units) do
		if not u[1].valid then
			table.remove(global.units, y)
		elseif u[2] > 0 and math.random(2) == 1 then u[2] = u[2] - 1
		elseif u[2] <= 0 then
			if u[3] ~= nil then
				table.insert(global.group[4], {u[3][1],1,u[3][3]})
			end
			u[1].destroy()
		end
	end
end